'use strict';
require('../../modules/es.object.to-string');
require('../../modules/es.array.iterator');
require('../../modules/es.array.values');
require('../../modules/web.dom-collections.values');

var classof = require('../../internals/classof');
var hasOwn = require('../../internals/has-own-property');
var isPrototypeOf = require('../../internals/object-is-prototype-of');
var arrayMethod = require('../array/virtual/values');

var ArrayPrototype = Array.prototype;

var DOMIterables = {
  DOMTokenList: true,
  NodeList: true,
};

module.exports = function (it) {
  var ownProperty = it.values;
  if (it === ArrayPrototype || ((isPrototypeOf(ArrayPrototype, it)
    || hasOwn(DOMIterables, classof(it)) && ownProperty === ArrayPrototype.values))) return arrayMethod;
  return ownProperty;
};
