'use strict';
var aTypedArrayConstructor = require('../internals/a-typed-array-constructor');
var exportTypedArrayStatic = require('../internals/export-typed-array-static');
var TYPED_ARRAY_CONSTRUCTORS_REQUIRE_WRAPPERS = require('../internals/typed-array-constructors-require-wrappers');

// `%TypedArray%.of` method
// https://tc39.es/ecma262/#sec-%typedarray%.of
exportTypedArrayStatic('of', function of(/* ...items */) {
  var index = 0;
  var length = arguments.length;
  var result = new (aTypedArrayConstructor(this))(length);
  while (length > index) result[index] = arguments[index++];
  return result;
}, TYPED_ARRAY_CONSTRUCTORS_REQUIRE_WRAPPERS);
